# Users

When using Whisk Recommendation and Personalization APIs client app needs to maintain User Identity in the platform

The `id`of a User is then being submitted when accessing `/feed` or`/search` endpoints.

Whisk considers User Preferences such as [diets](/resources/recipe-labels.md#diets) or [avoidances](/resources/recipe-labels.md#avoidances) and user impressions such as Like or View events to personalize the output

## Model

| ATTRIBUTE      | TYPE                                                  | DESCRIPTION                                                                                                                    |
| -------------- | ----------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------ |
| id\*           | string                                                | The id of the User on Whisk Graph                                                                                              |
| externalUserId | string                                                | The user id you have defined for the user. (Max limit of 255 UTF-8 characters, and should not have trailing or leading spaces) |
| email          | string                                                | The email you have defined for the user. (Max limit of 255 UTF-8 characters, and should not have trailing or leading spaces)   |
| firstName      | string                                                | The first name of the user                                                                                                     |
| lastName       | string                                                | The last name of the user                                                                                                      |
| displayName    | string                                                | The display name of the user                                                                                                   |
| createdAt      | timestamp                                             | The time the user was added to Whisk                                                                                           |
| updatedAt      | timestamp                                             | The last time the user was updated                                                                                             |
| pictureUrl     | string                                                | The profile picture url of a user                                                                                              |
| preferences    | [UserPreferences](/api/user-model.md#userpreferences) |                                                                                                                                |

### UserPreferences

| ATTRIBUTE             | TYPE            | DESCRIPTION                                                                                                           |
| --------------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| country               | string          | Country iso code. Examples: gb, kr, us...                                                                             |
| zipcode               | string          | Postal code. Examples: 10001, 80333...                                                                                |
| language              | string          | Language iso code. Examples: en, ko, fr...                                                                            |
| cookingSkill          | enum            | The measure of a person’s competence in preparing and cooking foods Possible values: amateur, intermediate, advanced. |
| gender                | enum            | Possible values: female, male.                                                                                        |
| householdSizeChildren | integer         | Number of children                                                                                                    |
| householdSizeAdults   | integer         | Number of adults Default value: 1                                                                                     |
| dislikedIngredients   | array \[string] | Products and ingredients which will be excluded in search and feed APIs.                                              |
| diets                 | array \[string] | more about diets                                                                                                      |
| avoidances            | array \[string] | more about avoidances                                                                                                 |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.whisk.com/api/user-model.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
